.386
.model flat, stdcall  ;32 bit memory model
option casemap :none  ;case sensitive


include \masm32\include\windows.inc 
include \masm32\include\user32.inc 
include \masm32\include\kernel32.inc 
include \masm32\include\masm32.inc
include \masm32\include\comctl32.inc
include \masm32\include\comdlg32.inc


include \masm32\include\gdi32.inc

includelib \masm32\lib\gdi32.lib
includelib \masm32\lib\comdlg32.lib
includelib \masm32\lib\user32.lib 
includelib \masm32\lib\kernel32.lib 
Includelib \masm32\lib\MASM32.LIB	
includelib \masm32\lib\comctl32.lib

include \masm32\include\debug.inc
includelib \masm32\lib\debug.lib
DBGWIN_DEBUG_ON = 1 ;turn it off if you don't want to include debug info into the program
DBGWIN_EXT_INFO = 1 ;turn it off if you don't want to include extra debug info into the program


DialogProc			PROTO	:HINSTANCE,:HINSTANCE,:LPSTR,:DWORD
InitDialog		PROTO	:HWND
;================================================================================
;================================================================================
m2m MACRO M1, M2
	push M2
	pop  M1
ENDM


.const

IDD_DLG1	Equ	1000
IDC_LSV1	Equ	1001
IDC_BTN1	Equ	1002
IDC_BTN2	Equ	1003


.data
hInstance		dd	0

szText			db		'Test',0

.data?
hwnd_ListView	dd	?
hBkGrnd			dd	?
hBitmap1		dd	?

.code

start:

	invoke GetModuleHandle,NULL
	mov		hInstance,eax

    invoke InitCommonControls
	invoke DialogBoxParam,hInstance,IDD_DLG1,NULL,addr DialogProc,NULL
	invoke ExitProcess,0
;================================================================================
;================================================================================
DialogProc proc hWnd:HWND,uMsg:UINT,wParam:WPARAM,lParam:LPARAM

	LOCAL	hdc:HDC, rect:RECT

	mov		eax,uMsg
	.if eax==WM_INITDIALOG
		invoke InitDialog, hWnd

	.ELSEIF uMsg == WM_ERASEBKGND				
		m2m hdc,wParam
		invoke GetClientRect, hWnd,ADDR rect
		invoke FillRect, hdc,ADDR rect, hBkGrnd   
		ret	

	.elseif eax==WM_CLOSE

		invoke EndDialog,hWnd,NULL
		
		
	.else
		mov		eax,FALSE
		ret
	.endif
	mov		eax,TRUE
	ret

DialogProc endp
;================================================================================
;================================================================================
InitDialog	Proc	uses esi edi ebx hWnd:HWND
	LOCAL   lvc:LV_COLUMN, Cont:DWORD
	LOCAL 	Item:LV_ITEM, Cont2:dword
	LOCAL 	bit:BITMAP				

	invoke GetDlgItem, hWnd, IDC_LSV1
	mov hwnd_ListView, eax

	invoke SendDlgItemMessage,hWnd, IDC_LSV1,LVM_SETEXTENDEDLISTVIEWSTYLE,\
							LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT,\
							LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT

	
	invoke SendDlgItemMessage,hWnd, IDC_LSV1,LVM_SETBKCOLOR,0,CLR_NONE
    invoke SendDlgItemMessage,hWnd, IDC_LSV1,LVM_SETTEXTBKCOLOR,0,CLR_NONE

		
	mov Item.imask,  LVIF_TEXT		
	mov Item.cchTextMax,256	 	
	
	mov lvc.fmt, LVCFMT_RIGHT
	mov lvc.imask, LVCF_TEXT or LVCF_WIDTH OR LVCF_FMT
    mov lvc.lx, 100
	
	lea ebx, szText
	mov lvc.pszText, ebx
	mov Cont, 0
	.while Cont < 4
		INVOKE SendDlgItemMessage,hWnd, IDC_LSV1, LVM_INSERTCOLUMN, Cont, addr lvc
		inc Cont
	.endw
	
	mov Cont, 0
	lea eax, szText
	mov Item.pszText,eax			
 	.while Cont < 20
		m2m Item.iItem, Cont
 		mov Cont2, 0
 		m2m Item.iSubItem, Cont2

		invoke SendDlgItemMessage,hWnd, IDC_LSV1, LVM_INSERTITEM, NULL, ADDR Item	

		.while Cont2 < 4
			inc Cont2
			m2m Item.iSubItem, Cont2
			invoke SendDlgItemMessage,hWnd, IDC_LSV1, LVM_SETITEM, NULL, ADDR Item
		.endw

		inc Cont
	.endw
	
	
	
;--------------------------------------------------------------------------------
;Create a Brush from Resource	
	invoke LoadBitmap,hInstance, 251	
	mov hBitmap1,eax

	invoke CreatePatternBrush,hBitmap1
	mov [hBkGrnd],eax

;--------------------------------------------------------------------------------
	
	
	
	
	ret
InitDialog endp
;================================================================================
;================================================================================




end start
